/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ranophoenix.osgijee.webclient.impl.cdi;

import java.util.ArrayList;
import java.util.List;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import javax.inject.Named;

import org.glassfish.osgicdi.ServiceContract;
import org.glassfish.osgicdi.ServiceRegistered;
import org.glassfish.osgicdi.ServiceUnregistering;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTracker;
import ranophoenix.osgijee.core.ModuleExtension;

/**
 *
 * @author ranophoenix
 * @author TangYong(tangyong@cn.fujitsu.com)
 */
@Named
@ApplicationScoped
public class ApplicationBean {

    @Inject
    private ServiceTracker st;
    @Inject
    private BundleContext bc;
    private List<ModuleExtension> modules = new ArrayList<ModuleExtension>();

    @Inject
    public void initialize(ServiceTracker st) {       
        loadServices();
    }

    public void afterAddModuleExtension(@Observes @ServiceContract(ModuleExtension.class) ServiceRegistered event) {
        System.out.println("Module added.");
        modules.add((ModuleExtension)event.getService());
    }

    public void beforeRemoveModuleExtension(@Observes @ServiceContract(ModuleExtension.class) ServiceUnregistering event) {
        System.out.println("Module removed");
        modules.remove((ModuleExtension)event.getService());
    }

    public List<ModuleExtension> getModules() {
        return modules;
    }

    //Waiting For finishing GLASSFISH-16805, and will use @Inject @OSGiService Instance<T>
    //feature to retrieve OSGi Services rather than using ServiceTracker
    private void loadServices() {
        ServiceReference[] srs = st.getServiceReferences();
        if (srs != null) {
            for (ServiceReference sr : srs) {
                ModuleExtension m = (ModuleExtension) bc.getService(sr);
                modules.add(m);
            }
        }
    }    
        
}
